(function () {
    "use strict";

    angular.module('core').controller('inventarioDetailController', controller);
    controller.$inject = ['$scope', '$timeout', 'Upload', '$state', '$stateParams', '$q', '$alert', 'inventarioService', 'lookupService', 'codigoBarraService'];

    function controller($scope, $timeout, Upload, $state, $stateParams, $q, $alert, inventarioService, lookupService, codigoBarraService) {

        $scope.initializeLayout('Inventário');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            qtItensAutoSave: 0 , /* variavél  auxiliar para realizar o auto-save*/
            tabCorrente: 0,
            tabs: {
                detalhes: 0,
                itensAjustados: 1,
                movimentacao: 2
            },
            itensAjusteInventario: {
                carregando: false,
                vazio: true,
                data: [],
                args: {
                    chaves: '',
                    filtro: {
                        Inventario: { ID: decodeURIComponent($stateParams.id) }
                    },
                    skip: 0,
                    take: 20
                }
            }
        };
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            }
        };
        $scope.popups = {
            itemInventario: {
                ativo: false,
                vazio: false,
                itens: [],
                filtro: {
                    codigo: '',
                    filtro: {
                        Status: 2
                    }
                },
                carregando: false,

                codigoProduto: null,
                itensAdicionado: [],

                prepareNewItem: function () {
                    if (!$scope.popups.itemInventario.filtro.codigo)
                        return;

                    $scope.popups.itemInventario.carregando = true;
                    var args = {
                        codigo: $scope.popups.itemInventario.filtro.codigo,
                        inventario: $scope.state.item
                    };
                    inventarioService
                        .prepareNewItem(args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                }
                                else {
                                    $scope.state.item = response.Data;
                                    $scope.popups.itemInventario.prepareFiltroProduto($scope.popups.itemInventario.filtro.codigo);
                                    $scope.popups.itemInventario.ativo = true;
                                }
                                $scope.popups.itemInventario.carregando = false;
                            },
                            function (_error) {
                                $scope.popups.itemInventario.carregando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepareFiltroProduto: function (codigoBarra) {
                    /* Após preparar o item pelo código de barras, descobre o 
                     código do produto bipado para filtrar a edição do item
                     alimentando a propriedade codigoProduto. */
                    $scope.popups.itemInventario.codigoProduto = null;
                    var args = { codigoBarra: codigoBarra };
                    codigoBarraService
                        .get(args)
                        .then(
                        function (response) {
                            if (response.Status >= 0) {
                                if (response.Data)
                                    $scope.popups.itemInventario.codigoProduto = response.Data.SKU.Produto.Codigo;
                                else
                                    $scope.popups.itemInventario.codigoProduto = $scope.popups.itemInventario.filtro.codigo;
                            }
                        });
                },
                prepareItem: function () {


                    inventarioService
                        .prepare({ inventario: $scope.state.item })
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.popups.itemInventario.ativo = false;
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.itemInventario.ativo = false;
                                    $scope.state.item = response.Data;


                                    /*caso tenha sido adicionado mais de 10 itens é realizado um auto-save*/
                                    if (($scope.state.qtItensAutoSave + 10) <= $scope.state.item.Itens.length) {

                                        $scope.state.qtItensAutoSave += 10;
                                        $scope.save(true);
                                    }

                                    $scope.popups.itemInventario.filtro.codigo = '';
                                }
                            },
                            function (_error) {
                                $scope.popups.itemInventario.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },

                toggle: function () {
                    $scope.popups.itemInventario.ativo = !$scope.popups.itemInventario.ativo;
                }
            },
            importar: {
                carregando: false,
                arquivo: { file: null, data: [], progressPercentage: 0, visible: true },
                upload: function () {
                    var file = $scope.popups.importar.arquivo.file;
                    if (file && !file.$error) {
                        $scope.popups.importar.carregando = true;
                        Upload
                            .upload({ url: '/inventario/ImportarContagemColetor', data: { item: $scope.state.item, file: file } })
                            .then(
                                function (response) {
                                    /* o response do upload é um pouco diferente do promise */
                                    if (response.data.Status < 0)
                                        $alert({ text: response.data.Message, title: $scope.Title });
                                    else {
                                        $scope.state.item = response.data.Data;
                                        $scope.popups.importar.toggle();
                                        if (response.data.Message) {
                                            $scope.popups.importExcecoes.data = angular.fromJson(response.data.Message);
                                            if ($scope.popups.importExcecoes.data.length > 0)
                                                $scope.popups.importExcecoes.toggle();
                                        }
                                    }
                                    $scope.popups.importar.carregando = false;
                                },
                                function (_error) {
                                    $scope.popups.importar.carregando = false;
                                    $scope.popups.importar.toggle();
                                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                                },
                                function (event) { $scope.popups.importar.arquivo.progressPercentage = parseInt(100.0 * event.loaded / event.total); }
                            );
                    }
                },
                toggle: function () {
                    $scope.popups.importar.ativo = !$scope.popups.importar.ativo;
                }
            },
            importExcecoes: {
                ativo: false,
                data: null,
                toggle: function () {
                    $scope.popups.importExcecoes.ativo = !$scope.popups.importExcecoes.ativo;
                },
            }
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            inventarioService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else { 
                            $scope.state.item = response.Data;
                            $scope.state.qtItensAutoSave = $scope.state.item.Itens.length;
                        }

                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    });
        };

        $scope.clearfiltro = function () {
            $scope.state.filtro = {
                args: {
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            };
        };

        $scope.getAllItemAjusteInventario = function () {
            $scope.state.itensAjusteInventario.args.skip = 0;
            $scope.state.itensAjusteInventario.args.take = 20;
            $scope.state.itensAjusteInventario.carregando = true;
            inventarioService
                .getAllItemAjusteInventario($scope.state.itensAjusteInventario.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        }
                        else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.itensAjusteInventario.data);
                        }
                        $scope.state.itensAjusteInventario.carregando = false;
                        $scope.state.itensAjusteInventario.vazio = (!angular.isArray($scope.state.itensAjusteInventario.data) || $scope.state.itensAjusteInventario.data.length === 0);
                    },
                    function (_error) {
                        $scope.state.itensAjusteInventario.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMoreItemAjusteInventario = function () {
            $scope.state.itensAjusteInventario.args.skip += $scope.state.itensAjusteInventario.args.take;
            $scope.state.itensAjusteInventario.carregando = true;
            inventarioService
                .getAllItemAjusteInventario($scope.state.itensAjusteInventario.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        }
                        else {
                            $scope.state.itensAjusteInventario.data = $scope.state.itensAjusteInventario.data.concat(response.Data);
                        }
                        $scope.state.itensAjusteInventario.carregando = false;
                        $scope.state.itensAjusteInventario.vazio = (!angular.isArray($scope.state.itensAjusteInventario.data) || $scope.state.itensAjusteInventario.data.length === 0);
                    },
                    function (_error) {
                        $scope.state.itensAjusteInventario.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.save = function (indicaAutoSave) {
            if ($scope.state.salvando)
                return;

            $scope.state.salvando = true;
            inventarioService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {

                            /*caso processo sejá auto-save não irá voltar para tela de detalhes de inventario */
                            if(angular.isUndefined(indicaAutoSave) || indicaAutoSave === null)
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };
        $scope.generateRomaneioAjusteInventario = function () {
            if ($scope.state.salvando)
                return;
            $scope.state.salvando = true;
            inventarioService
                .generateRomaneioAjusteInventario({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.tools.toastr.success('Ajuste realizado com êxito.');
                            $scope.state.item = response.Data;
                        }
                        $scope.state.salvando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error(_error);
                    });
        };
        $scope.cancel = function () {
            if ($scope.state.salvando)
                return;
            $scope.state.salvando = true;
            inventarioService
                .cancel({ id: $scope.state.item.ID })
                .then(function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    }
                    else {
                        $scope.state.item = response.Data;
                    }
                    $scope.state.salvando = false;
                    $scope.state.vazio = !$scope.state.item;
                }, function (_error) {
                    $scope.state.salvando = false;
                    $scope.tools.toastr.error(_error);
                });
        };

        $scope.print = function () {

            var divToPrint = document.getElementById('print');
            var newWin = window.open('', 'Print-Window');

            newWin.document.open();
            newWin.document.write('<html><head>' + getStyle() + '</head><body onload="window.print()">' + divToPrint.innerHTML + '</body></html>');

            newWin.document.close();

            //setTimeout(function () {
            //    newWin.close();
            //}, 10);
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.get();
        };

        $scope.initialize();
        $scope.$watch('popups.importar.arquivo.file', function () {
            /* verifica se o arquivo foi preenchido para upload e chama o upload */
            $scope.popups.importar.upload();
        });

    }

})();